using System;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;

namespace TSUDPCnt
{
    internal partial class Form1 : Form
    {
        /// <summary>ݒ</summary>
        Setting setting = Setting.Load();

        /// <summary>MNX</summary>
        private UDPSender udp = new UDPSender();

        /// <summary>
        /// RXgN^
        /// </summary>
        public Form1()
        {
            InitializeComponent();
            rabWhile.Tag = Setting.ChannelModeEnum.TERRESTRIAL;
            rabBlackBS.Tag = Setting.ChannelModeEnum.BS;
            rabBlackCS.Tag = Setting.ChannelModeEnum.CS;

            vlcprocess = new System.Diagnostics.Process();

            foreach(Setting.TSUDPData td in setting.TSUDPDatas)
            {
                cbxTSUDP.Items.Add(td);
            }
            if(cbxTSUDP.Items.Count>0)
                cbxTSUDP.SelectedIndex=0;

            SelectMode_CheckedChanged(rabWhile , EventArgs.Empty);
            udp.Port = (int)nudPort.Value;
        }

        /// <summary>AhX̐ݒ肪</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mskAddress_Validating(object sender , CancelEventArgs e)
        {
            MaskedTextBox msk = (MaskedTextBox)sender;
            try
            {
                byte[] byteAddress = new byte[4];
                for (int i = 0; i < 4; i++)
                {
                    byte b;
                    if (byte.TryParse(msk.Text.Substring(i * 4 , 3) , out b))
                    {
                        byteAddress[i] = b;
                    }
                    else
                    {
                        throw new ApplicationException("255ȉɂĂ");
                    }
                }
                if (msk == mskAddress)
                {
                    udp.IPAddress = new IPAddress(byteAddress);
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(this , ex.Message);
                e.Cancel = true;
            }
        }

        /// <summary>|[g̐ݒ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void nudPort_Validated(object sender , EventArgs e)
        {
            udp.Port = (int)nudPort.Value;
        }

        /// <summary>TSUDP̑MOnOff؂ւ{^NbN</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOnOff_Click(object sender , EventArgs e)
        {
            udp.SetCommand(1,chkOnOff.Checked ? 1U : 0U);
            udp.Send();
        }

        /// <summary>TSUDP̑M`l؂ւ{^NbN</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnChannel_Click(object sender , EventArgs e)
        {
            if (chkVLC.Checked && !vlcprocess.HasExited)
            {
                if (chkResetAtChannelChange.Checked)
                {
                    isResetVLC = true;
                    vlcprocess.Kill();
                }
                
            }

            ComboBox cbx = cbxChannel;
            if (cbx.SelectedIndex >= 0)
            {
                Setting.ChannelData cd = (Setting.ChannelData)cbx.Items[cbx.SelectedIndex];
                udp.SetCommand(cd.ChannelChangeCommandNumber , cd.Value);
                udp.Send();
            }
            
        }


        #region "VLC֌W"
        /// <summary>`lύXƂVLCċN邩</summary>
        private bool isResetVLC = false;
        /// <summary>NVLC̃vZX</summary>
        System.Diagnostics.Process vlcprocess;

        /// <summary>VLC̋N؂ւ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chkVLC_CheckedChanged(object sender , EventArgs e)
        {
            try
            {
                if (chkVLC.Checked)
                {
                    StartVLC();
                }
                else
                {
                    if (!vlcprocess.HasExited)
                    {
                        vlcprocess.Kill();
                    }
                }
            }
            catch 
            {
                vlcprocess.Close();
            }
        }

        /// <summary>VLCIƂɌĂяo</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void VLCExited(System.Object sender , EventArgs e)
        {
            if (this.InvokeRequired)
            {   //ʃXbh炭邩
                this.Invoke(new EventHandler(VLCExited),sender,e);
            }
            else
            {
                if (isResetVLC)
                {
                    StartVLC();
                }
                else
                {
                    chkVLC.Checked = false;
                }
            }
        }

        /// <summary>VLCN</summary>
        private void StartVLC()
        {
            string strAddress =string.Empty;
            //if (mskMultiAddress.Text  != "000.000.000.000")
            {
                byte b = byte.Parse(mskMultiAddress.Text.Substring(0 , 3));
                if ((b & 0xf0) == 0xe0)
                {
                    strAddress = mskMultiAddress.Text;
                }
            }
            string arg = setting.VLCOptions + @" udp:@" +strAddress + @":" + nudVLCPort.Value.ToString();
            vlcprocess = System.Diagnostics.Process.Start(setting.VLCPath , arg);
            vlcprocess.Exited += new EventHandler(VLCExited);
            vlcprocess.EnableRaisingEvents = true;
            isResetVLC = false;
        }
        #endregion


        /// <summary>nfWBSCŜǂ̃`lꗗ\邩؂ւ</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SelectMode_CheckedChanged(object sender , EventArgs e)
        {
            cbxChannel.Items.Clear();
            RadioButton rb = (RadioButton)sender;
            if (rb.Checked)
            {
                Setting.ChannelModeEnum cm = (Setting.ChannelModeEnum)rb.Tag;
                foreach (Setting.ChannelData cd in setting.GetChannelList(cm))
                {
                    if (cd.Enable)
                    {
                        cbxChannel.Items.Add(cd);
                    }
                }
                if (cbxChannel.Items.Count > 0)
                {
                    cbxChannel.SelectedIndex = 0;
                }
            }
        }

        /// <summary>TSUDPݒꗗ̑IύX</summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cbxTSUDP_SelectedIndexChanged(object sender , EventArgs e)
        {
            Setting.TSUDPData td = (Setting.TSUDPData)cbxTSUDP.Items[cbxTSUDP.SelectedIndex];

            mskAddress.Text = td.CommandAddress;
            nudPort.Value = td.CommandPort;
            mskAddress_Validating(mskAddress , new CancelEventArgs());
            udp.Port = td.CommandPort;

            mskMultiAddress.Text = td.MulticastAddress;
            nudVLCPort.Value = td.SendPort;

            RadioStateChange(rabWhile , td.SupportTypeFlags);
            RadioStateChange(rabBlackBS , td.SupportTypeFlags);
            RadioStateChange(rabBlackCS , td.SupportTypeFlags);
        }
        private void RadioStateChange(RadioButton rab , Setting.ChannelModeEnum cmFlag)
        {
            Setting.ChannelModeEnum cmRadio = (Setting.ChannelModeEnum)rab.Tag;
            if ((cmFlag & cmRadio) != cmRadio)
            {
                rab.Enabled = false;
                rab.Enabled = false;
                if (rab.Checked)
                {
                    rab.Checked = false;
                }
            }
            else
            {
                rab.Enabled = true;
            }
        }
    }

    /// <summary>
    /// R}hpPbg̑MpNX
    /// </summary>
    internal class UDPSender : IDisposable 
    {
        private System.Net.Sockets.UdpClient udp = new System.Net.Sockets.UdpClient();
        System.Net.IPEndPoint endpoint = new System.Net.IPEndPoint(System.Net.IPAddress.None , 0);
        byte[] buff = new byte[19];

        /// <summary>R}hMIPAhX</summary>
        public IPAddress IPAddress
        {
            get
            {
                return endpoint.Address;
            }
            set
            {
                endpoint.Address = value;
            }
        }

        /// <summary>R}hM̃|[g</summary>
        public int Port
        {
            get
            {
                return endpoint.Port;
            }
            set
            {
                endpoint.Port = value;
            }
        }

        /// <summary>RXgN^</summary>
        public UDPSender()
        {
            byte[] btemp;
            btemp = System.Text.Encoding.ASCII.GetBytes("TSUDP");
            Array.Copy(btemp , buff , 5);
        }

        /// <summary>MR}h̃f[^Zbg</summary>
        /// <param name="number">R}hԍ</param>
        /// <param name="value">R}h̒l</param>
        public void SetCommand(UInt32 number , UInt32 value)
        {
            byte[] btemp;
            btemp = System.BitConverter.GetBytes(number);
            Array.Copy(btemp , 0 , buff , 9 , 4);
            btemp = System.BitConverter.GetBytes(value);
            Array.Copy(btemp , 0 , buff , 13 , 4);

            //lbg[NɗȂ{̓rbOGfBAɂׂ
            //łʓ|炻̂܂
        }

        /// <summary>R}hM</summary>
        public void Send()
        {
            udp.Send(buff , buff.Length , endpoint);
        }

        #region IDisposable o

        public void Dispose()
        {
            udp.Close();
        }

        #endregion
    }

    /// <summary>ݒpNX</summary>
    public class Setting
    {
        /// <summary>VLCւ̃pX</summary>
        public string VLCPath
        {
            get { return _VLCPath; }
            set { _VLCPath = System.Environment.ExpandEnvironmentVariables(value);}
        }
        private string _VLCPath;

        
        /// <summary>BSCS̃`lf[^ւ̃pX</summary>
        public string BSCSiniPath
        {
            get { return _BSCSiniPath; }
            set { _BSCSiniPath = System.Environment.ExpandEnvironmentVariables(value);}
        }
        private string _BSCSiniPath;

        /// <summary>VLCǉIvV</summary>
        public string VLCOptions;

        /// <summary>ݒǂݍݗpt@Ng</summary>
        /// <returns></returns>
        /// <exception cref="System.IO.Exception">ݒt@C</exception>
        public static Setting Load()
        {
            System.Xml.Serialization.XmlSerializer seri
                = new System.Xml.Serialization.XmlSerializer(typeof(Setting),new System.Type[]{typeof(ChannelData),typeof(TSUDPData)});
            using (System.IO.StreamReader sr = new System.IO.StreamReader("TSUDPCnt.xml"))
            {
                return  (Setting)seri.Deserialize(sr);
            }
        }

        /// <summary>`lǂ̕g</summary>
        public enum ChannelModeEnum : uint
        {
            /// <summary>s</summary>
            UNKNOWN = 0 ,
            /// <summary>nfW</summary>
            TERRESTRIAL = 1 ,
            /// <summary>BS</summary>
            BS = 2 ,
            /// <summary>CS</summary>
            CS = 4 ,
            /// <summary>BSCS̗Ή</summary>
            BSCS = 6
        }

        /// <summary>`lf[^̔z</summary>
        public ChannelData[] ChannelDatas;

        /// <summary>w肵g̃`lf[^ꗗ̎擾</summary>
        /// <param name="cm">og̎w</param>
        /// <returns></returns>
        public System.Collections.IEnumerable GetChannelList(ChannelModeEnum cm)
        {
            foreach (ChannelData cd in ChannelDatas)
            {
                if (cd.ChannelMode == cm)
                {
                    yield return cd;
                }
            }
        }

        /// <summary>BSCS̃`lf[^p</summary>
        public class ChannelData
        {
            /// <summary>`l</summary>
            public string Name;
            /// <summary>`lf[^1</summary>
            public UInt16 Value1;
            /// <summary>`lf[^2</summary>
            public UInt16 Value2;

            public override string ToString()
            {
                return Name;
            }

            /// <summary>R}hɓl</summary>
            public virtual UInt32 Value
            {
                get
                {
                    return ((UInt32)Value1 << 16) | (UInt32)Value2;
                }
            }

            
            /// <summary>`lf[^̎</summary>
            public  ChannelModeEnum ChannelMode
            {
                get
                {
                    return _ChannlModeEnum;
                }
                set
                {
                    _ChannlModeEnum = value;
                }
            }
            private ChannelModeEnum _ChannlModeEnum = ChannelModeEnum.UNKNOWN;

            /// <summary>̃`l̂Ƃ̃`lR}h̔ԍ</summary>
            public uint ChannelChangeCommandNumber
            {
                get
                {
                    switch (ChannelMode)
                    {
                    case ChannelModeEnum.TERRESTRIAL:
                    case ChannelModeEnum.BS:
                        return 2; //`l̂ݐ؂ւ
                    case ChannelModeEnum.CS:
                        return 4; //`lƃT[rXꊇ؂ւ
                    default:
                        return 0;
                    }
                }
            }

            public bool Enable = false;
        }

        public TSUDPData[] TSUDPDatas;

        /// <summary>삷TSUDPɊւf[^̐ݒpNX</summary>
        public class TSUDPData
        {
            /// <summary>\p̖O</summary>
            public string Name = string.Empty;

            /// <summary>TSUDPǂ̕gFriioȂ̂</summary>
            public ChannelModeEnum SupportTypeFlags = ChannelModeEnum.UNKNOWN;

            /// <summary>R}h𑗂AhX</summary>
            public string CommandAddress
            {
                get { return _CommandAddress; }
                set { _CommandAddress = ForMaskText( value); }
            }
            private string _CommandAddress;
            /// <summary>R}h𑗂|[g</summary>
            public UInt16 CommandPort = 0;

            
            /// <summary>}`LXgőĂꍇ̃AhX</summary>
            public string MulticastAddress
            {
                get { return _MulticastAddress; }
                set { _MulticastAddress = ForMaskText(value); }
            }
            private string _MulticastAddress;

            /// <summary>Ă|[g</summary>
            public UInt16 SendPort = 0;

            public override string ToString()
            {
                return Name;
            }

            /// <summary>MaskTextBoxɕ\ł镶擾</summary>
            /// <param name="addr"></param>
            /// <returns></returns>
            private string ForMaskText(string addr)
            {
                string ret = "000.000.000.000";
                string strTemp = string.Empty;
                foreach (string s in addr.Split('.'))
                {
                    strTemp += ("000" + s).Substring(s.Length ,3);
                    strTemp += ".";
                }
                if (strTemp.Length == 16)
                {
                    ret = strTemp.Substring(0 , 15);
                }
                return ret;
            }
        }
    }
}